
do
	local ROAIPlus = {
		DEBUG_PRINT = false,	-- fobOo
		PUBLIC = false,	-- e[uJ()
	}
	local globals = {}	-- Ԃ_G
	local loaded	-- ǂݍAI
	local Params	-- p[^ v[Xz_
	
	-- CopyTable ȂǂŎg֐̓obNAbvĂ
	local raw_pairs = pairs
	local raw_io_open = io.open
	local raw_os_remove = os.remove
	local raw_os_rename = os.rename
	
	local function DebugPrint( ... )
		if not ROAIPlus.DEBUG_PRINT then
			return
		end
		local msg = ""
		for i,v in ipairs( arg ) do
			msg = msg..tostring( v ).."\t"
		end
		globals.TraceAI( msg )
	end
	
	local function CopyTable( t1, t2 )
		for k,v in raw_pairs( t1 ) do
		-- xʂƂȂIOtbLO܂ȂȂ̂Ő󂢃Rs[
		--	if type( v ) == "table" and t1 ~= v then	-- _G._G Ȃǂ̏zQƂ͏O
		--		local t = {}	-- qe[u̓N[jO
		--		CopyTable( v, t )
		--		t2[k] = t
		--	else
				t2[k] = v
		--	end
		end
	end
	
	local function CloneTable( t1, t2 )
		CopyTable( t1, t2 )
		for k,v in raw_pairs( t2 ) do	-- t2 ɂ t1 ɂȂCfbNX菜
			if not t1[k] then
				t2[k] = nil
			end
		end
	end
	
	local function DumpTable( t )
		DebugPrint("-- Dump Table: "..globals.tostring(t) )
		for k,v in globals.pairs( t ) do
			DebugPrint( globals.tostring(k)..": "..globals.tostring(v) )
		end
		DebugPrint("-- ")
	end
	
	CopyTable( _G, globals )	-- `ĂȂԂ̃O[oRs[
	
	local function InjectFileIO( parent, name, raw_func, dir )
		parent[ name ] = function( ... )
			DebugPrint("Call IO: "..name );
			for i,v in ipairs( arg ) do
				if type( v ) == "string" then
					arg[i] = globals.string.gsub( v, "USER_AI", dir )	-- USER_AI𐳂tH_
				end
				DebugPrint("arg "..i..": "..tostring(arg[i]) )
			end
			local r = raw_func( unpack( arg ) )
			DebugPrint("return: "..globals.tostring(r))
			return r
		end
	end
	
	local traceQueue = { n = 0 }
	local prevText
	local traceCount = 0
	
	local function CustomTraceAI( text )
		if not Params.HOOK_TRACEAI then	-- JX^TraceAI
			globals.TraceAI( text )
			return
		end
		if Params.SAVE_TRACEAI then
			globals.TraceAI( text )
		end
		if Params.IGNORE_REPEAT and prevText == text then
			return
		end
		traceQueue.n = traceQueue.n + 1
		traceQueue[ traceQueue.n ] = globals.os.date("%X").." "..text.."\n"
		prevText = text
	end
	
	local function FlushTraceAI()
		if traceQueue.n == 0 then
			return
		end
		local name = "./AI/USER_AI/temp/TraceAI/"..string.format("%010d", traceCount + 1 )
		local fp = raw_io_open( name, "w")
		if not fp then
			DebugPrint("TraceAI Open Error: "..name )
			return
		end
		for i,v in ipairs( traceQueue ) do
			fp:write( v )
		end
		fp:close()
		traceQueue = { n = 0 }
		traceCount = traceCount + 1
	end
	
	local function LoadChunk( path )
		local chunk = globals.loadfile( path )
		if chunk then
			return chunk()
		end
		return nil
	end
	
	local InjectAIEntryPoint
	
	local function LoadAI( name )
		if not name or name == "USER_AI" then	-- USER_AI ͖[v̂ŏO
			return
		end
		DumpTable( _G )
		CloneTable( globals, _G )	-- O[oԂ֖߂
		_G._LOADED = {}
		globals.collectgarbage()
		DumpTable( _G )
		InjectFileIO( _G, "require", globals.require, name )	-- o͊֐tbLOāAt@CpXU
		InjectFileIO( _G, "loadfile", globals.loadfile, name )
		InjectFileIO( _G, "dofile", globals.dofile, name )
		InjectFileIO( _G.io, "open", raw_io_open, name )	-- globals.io.open ㏑Ă܂̂ŁAnƖ[v
		InjectFileIO( _G.os, "remove", raw_os_remove, name )
		InjectFileIO( _G.os, "rename", raw_os_rename, name )
		TraceAI = CustomTraceAI
		globals.dofile("./AI/"..name.."/AI.lua")
		DumpTable( _LOADED )
		if not AI then	-- AI֐Ȃ
			DebugPrint("Not Declared function AI") 	--  globals OĂ݂
		end
		loaded = name
		InjectAIEntryPoint()
	end
	
	InjectAIEntryPoint = function()
		local raw_AI = AI	-- ǂݍAIAI֐ۑ
		AI = function( myid ) 	-- AI֐bv
			local params = LoadChunk("./AI/USER_AI/params.lua")
			Params = params or Params or {}	-- [hɎsȑO Params p
			if raw_AI then
				raw_AI( myid )
				FlushTraceAI()
			end
			local ai = Params.CURRENT_AI
			if loaded ~= ai then	-- AIقȂ
				LoadAI( ai )
			end
		end
	end
	
	InjectAIEntryPoint()	-- AIǂݍ܂܂Ŏs
end
